=== debian/changelog ===
cadabra2 (2.3.9.3-1) unstable; urgency=medium

  * New upstream release. (Closes: #1008690, #982455)
  * d/clean: updated.
  * d/rules: skip dh_shlibdeps.
  * d/copyright: bump years.
  * Bump standards version to 4.6.1.
  * d/control:
    - update maintainer address.
    - update libpcre3-dev to libpcre2-dev. (Closes: #1000102)

 -- Gürkan Myczko <tar@debian.org>  Sun, 14 Aug 2022 10:48:43 +0200
