## cadabra2 2.4.0.2

=== debian/changelog ===
cadabra2 (2.4.0.2-2build1) lunar; urgency=medium

  * No-change rebuild with Python 3.11 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 25 Dec 2022 19:37:51 +0000

cadabra2 (2.4.0.2-2) unstable; urgency=medium

  * Fix unusual python3 location warning.
  * d/copyright: drop FindPCRE.cmake part.

 -- Gürkan Myczko <tar@debian.org>  Thu, 13 Oct 2022 09:06:04 +0200

cadabra2 (2.4.0.2-1) unstable; urgency=medium

  * New upstream release. (Closes: #1019333, #1019988)

 -- Gürkan Myczko <tar@debian.org>  Thu, 06 Oct 2022 13:50:59 +0200
